﻿--------------------------------------------------------------------------------------------
-- Name: PlaySound
-- Author: Mulesh
-- Version: 4.6
-- Description: Play sound files for abilities and events
--------------------------------------------------------------------------------------------
local TimeSinceLastUpdate = 0
local PlaySound_Mount = false
local PlaySound_TLowHealth = false

function PlaySound_OnLoad()
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE") -- Ability Damage
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF") -- Ability Healing
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS") -- Ability Buffing
	this:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED") -- Ability Misc
	this:RegisterEvent("PLAYER_AURAS_CHANGED") -- mounted
	this:RegisterEvent("UI_ERROR_MESSAGE") -- Out of Range
	this:RegisterEvent("PLAYER_DEAD") -- Death
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH") -- Killing Blow
	this:RegisterEvent("PLAYER_LEVEL_UP") -- Level Up
	this:RegisterEvent("UNIT_HEALTH") -- Target Low Health
	this:RegisterEvent("PLAYER_TARGET_CHANGED") -- reset Target Low Health
	--this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") -- Debuff
	
	SLASH_PLAYSOUND1 = "/playsound"
	SLASH_PLAYSOUND2 = "/plays"
	SlashCmdList["PLAYSOUND"] = PlaySound_SlashHandler
end

function PlaySound_SlashHandler()
	PlaySound_Editor:Show()
end

--[[function PlaySound_OnUpdate(elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	while (TimeSinceLastUpdate > 1) do
		PlaySound_Mounted()
		TimeSinceLastUpdate = TimeSinceLastUpdate - 1
	end
end]]

function PlaySound_OnEvent()
	if (event == "ADDON_LOADED" and arg1 == "PlaySound") then
		if (not PlaySound_CharVar) then
			PlaySound_CharVar = {}
		end
		if (not PlaySound_CharVar.Abilities) then
			PlaySound_CharVar.Abilities = {}
			for Key, Value in pairs(PlaySound_Abilities) do
				if (UnitClass("player") == Key) then
					for i=1, #Value do
						table.insert(PlaySound_CharVar.Abilities,Value[i])
					end
				end
			end
		end
		if (not PlaySound_CharVar.Other) then
			PlaySound_CharVar.Other = {}
		end
		if (PlaySound_CharVar.Abilities) then
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == "Summon Dreadsteed") then
					table.remove(PlaySound_CharVar.Abilities,Key)
				end
			end
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == "Summon Felsteed") then
					table.remove(PlaySound_CharVar.Abilities,Key)
				end
			end
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == "Summon Warhorse") then
					table.remove(PlaySound_CharVar.Abilities,Key)
				end
			end
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == "Summon Charge") then
					table.remove(PlaySound_CharVar.Abilities,Key)
				end
			end
		end
		PlaySound_FauxDropDown_Data = {}
		for i=1, #PlaySound_CharVar.Abilities do
			PlaySound_FauxDropDown_Data[i] = PlaySound_CharVar.Abilities[i][1]
		end
		PlaySound_FauxDropDown_ScrollBar:Show()
	end
	---------------------------------------------------------------------------------------------
	-- Normal Sound for damage abilities
	---------------------------------------------------------------------------------------------
	if (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		for spellname, target, damage in string.gmatch(arg1, "Your (.+) hits (.+) for (%d+).") do
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == spellname) and (Value[2]) then
					local sound = Value[2]
					PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				end
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Critical Sound for damage abilities
	---------------------------------------------------------------------------------------------
	if (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		for spellname, target, damage in string.gmatch(arg1, "Your (.+) crits (.+) for (%d+).") do
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == spellname) and (Value[3]) then
					local sound = Value[3]
					PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				end
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Normal Sound for healing abilities
	---------------------------------------------------------------------------------------------
	if (event == "CHAT_MSG_SPELL_SELF_BUFF") then
		for spellname, target, damage in string.gmatch(arg1, "Your (.+) heals (.+) for (%d+).") do
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == spellname) and (Value[2]) then
					local sound = Value[2]
					PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				end
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Critical Sound for healing abilities
	---------------------------------------------------------------------------------------------
	if (event == "CHAT_MSG_SPELL_SELF_BUFF") then
		for spellname, target, damage in string.gmatch(arg1, "Your (.+) critically heals (.+) for (%d+).") do
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == spellname) and (Value[3]) then
					local sound = Value[3]
					PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				end
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Normal Sound for buff abilities
	---------------------------------------------------------------------------------------------
	if (event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS") then
		for spellname in string.gmatch(arg1, "You gain (.+).") do
			for Key, Value in pairs(PlaySound_CharVar.Abilities) do
				if (Value[1] == spellname) and (Value[2]) then
					local sound = Value[2]
					PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				end
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Normal Sound for misc abilities
	---------------------------------------------------------------------------------------------
	if (event == "UNIT_SPELLCAST_SUCCEEDED" and arg1 == "player") then
		for Key, Value in pairs(PlaySound_CharVar.Abilities) do
			if (Value[1] == arg2) and (Value[2]) then
				if (string.find(Value[1], "^Conjure.*"))
				or (string.find(Value[1], "^Portal.*"))
				or (string.find(Value[1], "^Create.*"))
				or (string.find(Value[1], "Life Tap"))
				or (string.find(Value[1], "Summon Imp"))
				or (string.find(Value[1], "Summon Voidwalker"))
				or (string.find(Value[1], "Summon Succubus"))
				or (string.find(Value[1], "Summon Felhunter")) then
					local sound = Value[2]
					PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				end
			end
		end
	end	
	---------------------------------------------------------------------------------------------
	-- Mounted Sound
	---------------------------------------------------------------------------------------------
	if (event == "PLAYER_AURAS_CHANGED") then
		local TimeSinceLastUpdate = 0
		PlaySound_Trigger:SetScript("OnUpdate", function(_, elapsed)
			TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
			if (TimeSinceLastUpdate >= 1) then
				PlaySound_Trigger:SetScript("OnUpdate", nil)
				if IsMounted() then
					if (PlaySound_CharVar.Other[10]) then
						local sound = PlaySound_CharVar.Other[10]
						PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
					end
				end
			end
		end)
	end
	---------------------------------------------------------------------------------------------
	-- Killing Blow Sound
	---------------------------------------------------------------------------------------------
	if (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
		for targetname in string.gmatch(arg1, "You have slain (.+)") do
			if (PlaySound_CharVar.Other[1]) then
				local sound = PlaySound_CharVar.Other[1]
				PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Death Sound
	---------------------------------------------------------------------------------------------
	if (event == "PLAYER_DEAD") then
		if (PlaySound_CharVar.Other[2]) then
			local sound = PlaySound_CharVar.Other[2]
			PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
		end
	end
	---------------------------------------------------------------------------------------------
	-- Out of Range Sound
	---------------------------------------------------------------------------------------------
	if (event == "UI_ERROR_MESSAGE") then
		if (arg1 == "Out of range.") then
			if (PlaySound_CharVar.Other[3]) then
				local sound = PlaySound_CharVar.Other[3]
				PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
			end
		end
	end
	---------------------------------------------------------------------------------------------
	-- Level Up Sound
	---------------------------------------------------------------------------------------------
	if (event == "PLAYER_LEVEL_UP") then
		if (PlaySound_CharVar.Other[4]) then
			local sound = PlaySound_CharVar.Other[4]
			PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
		end
	end
	---------------------------------------------------------------------------------------------
	-- Debuff Sound
	---------------------------------------------------------------------------------------------
	--[[if (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
		for spellname in string.gmatch(arg1, "You are (.+).") do
			for i=1,40 do
				local name, _, _, _, Dtype = UnitDebuff("player",i)
				if (Dtype == "Poison") then
					if (PlaySound_CharVar.Other[5]) then
						local sound = PlaySound_CharVar.Other[5]
						PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
					end
				end
			end
		end
	end]]	
	---------------------------------------------------------------------------------------------
	-- Target Low Health Sound
	---------------------------------------------------------------------------------------------
	if (event == "UNIT_HEALTH") and (arg1 == "target") then
		local targetHealth = UnitHealth("target")
		if (targetHealth < 20) and (targetHealth > 0) and (PlaySound_TLowHealth == false) and (not (UnitIsFriend("player", "target"))) then
			if (PlaySound_CharVar.Other[11]) then
				local sound = PlaySound_CharVar.Other[11]
				PlaySoundFile("Interface\\AddOns\\PlaySound\\Sounds\\"..sound)
				PlaySound_TLowHealth = true
			end
		elseif (targetHealth <= 0) then
			PlaySound_TLowHealth = false
		end
	end
	if (event == "PLAYER_TARGET_CHANGED") then
		PlaySound_TLowHealth = false
	end
end

---------------------------------------------------------------------------------------------
-- GUI functions
---------------------------------------------------------------------------------------------
function PlaySound_Editor_Hide()
	PlaySound_Editor:Hide()
	if (PlaySound_FauxDropDown:IsShown()) then
		PlaySound_FauxDropDown:Hide()
	end
end

function PlaySound_Editor_OnShow()
	getglobal("PlaySound_Editor_Abilities"):Show()
	getglobal("PlaySound_Editor_Abilities_Tab"):SetNormalTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	getglobal("PlaySound_Editor_KillingBlow"):Hide()
	getglobal("PlaySound_Editor_KillingBlow_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_Death"):Hide()
	getglobal("PlaySound_Editor_Death_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_OutofRange"):Hide()
	getglobal("PlaySound_Editor_OutofRange_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_LevelUp"):Hide()
	getglobal("PlaySound_Editor_LevelUp_Tab"):SetNormalTexture(nil)
	--getglobal("PlaySound_Editor_Debuff"):Hide()
	--getglobal("PlaySound_Editor_Debuff_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_Mount"):Hide()
	getglobal("PlaySound_Editor_Mount_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_TLowHealth"):Hide()
	getglobal("PlaySound_Editor_TLowHealth_Tab"):SetNormalTexture(nil)
end

function PlaySound_Tab_OnClick()
	getglobal("PlaySound_Editor_Abilities_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_KillingBlow_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_Death_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_OutofRange_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_LevelUp_Tab"):SetNormalTexture(nil)
	--getglobal("PlaySound_Editor_Debuff_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_Mount_Tab"):SetNormalTexture(nil)
	getglobal("PlaySound_Editor_TLowHealth_Tab"):SetNormalTexture(nil)
	this:SetNormalTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	local tabID = this:GetName()
	if (tabID == "PlaySound_Editor_Abilities_Tab") then
		getglobal("PlaySound_Editor_Abilities"):Show()
	else
		getglobal("PlaySound_Editor_Abilities"):Hide()
	end
	if (tabID == "PlaySound_Editor_KillingBlow_Tab") then
		getglobal("PlaySound_Editor_KillingBlow"):Show()
		if (PlaySound_CharVar.Other[1]) then
			getglobal("PlaySound_Editor_KillingBlow_EditBox1"):SetText(PlaySound_CharVar.Other[1])
		end
	else
		getglobal("PlaySound_Editor_KillingBlow"):Hide()
	end
	if (tabID == "PlaySound_Editor_Death_Tab") then
		getglobal("PlaySound_Editor_Death"):Show()
		if (PlaySound_CharVar.Other[2]) then
			getglobal("PlaySound_Editor_Death_EditBox1"):SetText(PlaySound_CharVar.Other[2])
		end
	else
		getglobal("PlaySound_Editor_Death"):Hide()
	end
	if (tabID == "PlaySound_Editor_OutofRange_Tab") then
		getglobal("PlaySound_Editor_OutofRange"):Show()
		if (PlaySound_CharVar.Other[3]) then
			getglobal("PlaySound_Editor_OutofRange_EditBox1"):SetText(PlaySound_CharVar.Other[3])
		end
	else
		getglobal("PlaySound_Editor_OutofRange"):Hide()
	end
	if (tabID == "PlaySound_Editor_LevelUp_Tab") then
		getglobal("PlaySound_Editor_LevelUp"):Show()
		if (PlaySound_CharVar.Other[4]) then
			getglobal("PlaySound_Editor_LevelUp_EditBox1"):SetText(PlaySound_CharVar.Other[4])
		end
	else
		getglobal("PlaySound_Editor_LevelUp"):Hide()
	end
	--[[if (tabID == "PlaySound_Editor_Debuff_Tab") then
		getglobal("PlaySound_Editor_Debuff"):Show()
		if (PlaySound_CharVar.Other[5]) then
			getglobal("PlaySound_Editor_Debuff_EditBox1"):SetText(PlaySound_CharVar.Other[5])
		end
		if (PlaySound_CharVar.Other[6]) then
			getglobal("PlaySound_Editor_Debuff_EditBox2"):SetText(PlaySound_CharVar.Other[6])
		end
		if (PlaySound_CharVar.Other[7]) then
			getglobal("PlaySound_Editor_Debuff_EditBox3"):SetText(PlaySound_CharVar.Other[7])
		end
		if (PlaySound_CharVar.Other[8]) then
			getglobal("PlaySound_Editor_Debuff_EditBox4"):SetText(PlaySound_CharVar.Other[8])
		end
		if (PlaySound_CharVar.Other[9]) then
			getglobal("PlaySound_Editor_Debuff_EditBox5"):SetText(PlaySound_CharVar.Other[9])
		end
	else
		getglobal("PlaySound_Editor_Debuff"):Hide()
	end]]
	if (tabID == "PlaySound_Editor_Mount_Tab") then
		getglobal("PlaySound_Editor_Mount"):Show()
		if (PlaySound_CharVar.Other[10]) then
			getglobal("PlaySound_Editor_Mount_EditBox1"):SetText(PlaySound_CharVar.Other[10])
		end
	else
		getglobal("PlaySound_Editor_Mount"):Hide()
	end
	if (tabID == "PlaySound_Editor_TLowHealth_Tab") then
		getglobal("PlaySound_Editor_TLowHealth"):Show()
		if (PlaySound_CharVar.Other[11]) then
			getglobal("PlaySound_Editor_TLowHealth_EditBox1"):SetText(PlaySound_CharVar.Other[11])
		end
	else
		getglobal("PlaySound_Editor_TLowHealth"):Hide()
	end
end

function PlaySound_EditBox_ClearButton_OnClick(box)
	if (box == "Abilities_Normal") then
		getglobal("PlaySound_Editor_Abilities_EditBox1"):SetText("")
	elseif (box == "Abilities_Crit") then
		getglobal("PlaySound_Editor_Abilities_EditBox2"):SetText("")
	elseif (box == "KillingBlow") then
		getglobal("PlaySound_Editor_KillingBlow_EditBox1"):SetText("")
	elseif (box == "Death") then
		getglobal("PlaySound_Editor_Death_EditBox1"):SetText("")
	elseif (box == "OutofRange") then
		getglobal("PlaySound_Editor_OutofRange_EditBox1"):SetText("")
	elseif (box == "LevelUp") then
		getglobal("PlaySound_Editor_LevelUp_EditBox1"):SetText("")
	--[[elseif (box == "Debuff_Poison") then
		getglobal("PlaySound_Editor_Debuff_EditBox1"):SetText("")
	elseif (box == "Debuff_Disease") then
		getglobal("PlaySound_Editor_Debuff_EditBox2"):SetText("")
	elseif (box == "Debuff_Curse") then
		getglobal("PlaySound_Editor_Debuff_EditBox3"):SetText("")
	elseif (box == "Debuff_Magic") then
		getglobal("PlaySound_Editor_Debuff_EditBox4"):SetText("")
	elseif (box == "Debuff_Other") then
		getglobal("PlaySound_Editor_Debuff_EditBox5"):SetText("")]]
	elseif (box == "Mount") then
		getglobal("PlaySound_Editor_Mount_EditBox1"):SetText("")
	elseif (box == "TLowHealth") then
		getglobal("PlaySound_Editor_TLowHealth_EditBox1"):SetText("")
	end
	PlaySound_SaveButton_OnClick()
end

function PlaySound_SaveButton_OnClick()
	if (PlaySound_Editor_Abilities:IsVisible()) then
		local PlaySoundTemp = {}
		PlaySoundTemp[1]=PlaySound_Editor_Abilities_FauxDropDownText:GetText()
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_Abilities_EditBox1"):GetText())
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_Abilities_EditBox2"):GetText())
		for i=1,#PlaySound_CharVar.Abilities do
			if (PlaySoundTemp[1] == PlaySound_CharVar.Abilities[i][1]) then
				if (PlaySoundTemp[2] == "") then
					PlaySound_CharVar.Abilities[i][2] = nil
				else
					PlaySound_CharVar.Abilities[i][2] = PlaySoundTemp[2]
				end
				if (PlaySoundTemp[3] == "") then
					PlaySound_CharVar.Abilities[i][3] = nil
				else
					PlaySound_CharVar.Abilities[i][3] = PlaySoundTemp[3]
				end
			break
			end
		end
	end
	if (PlaySound_Editor_KillingBlow:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_KillingBlow_EditBox1"):GetText())
		if (PlaySoundTemp[1] == "") then
			PlaySound_CharVar.Other[1] = nil
		else
			PlaySound_CharVar.Other[1] = PlaySoundTemp[1]
		end
	end
	if (PlaySound_Editor_Death:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_Death_EditBox1"):GetText())
		if (PlaySoundTemp[1] == "") then
			PlaySound_CharVar.Other[2] = nil
		else
		PlaySound_CharVar.Other[2] = PlaySoundTemp[1]
		end
	end
	if (PlaySound_Editor_OutofRange:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_OutofRange_EditBox1"):GetText())
		if (PlaySoundTemp[1] == "") then
			PlaySound_CharVar.Other[3] = nil
		else
			PlaySound_CharVar.Other[3] = PlaySoundTemp[1]
		end
	end
	if (PlaySound_Editor_LevelUp:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_LevelUp_EditBox1"):GetText())
		if (PlaySoundTemp[1] == "") then
			PlaySound_CharVar.Other[4] = nil
		else
			PlaySound_CharVar.Other[4] = PlaySoundTemp[1]
		end
	end
	--[[if (PlaySound_Editor_Debuff:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp[5],getglobal("PlaySound_Editor_Debuff_EditBox1"):GetText())
		table.insert(PlaySoundTemp[6],getglobal("PlaySound_Editor_Debuff_EditBox2"):GetText())
		table.insert(PlaySoundTemp[7],getglobal("PlaySound_Editor_Debuff_EditBox3"):GetText())
		table.insert(PlaySoundTemp[8],getglobal("PlaySound_Editor_Debuff_EditBox4"):GetText())
		table.insert(PlaySoundTemp[9],getglobal("PlaySound_Editor_Debuff_EditBox5"):GetText())
		for i=5,9 do
			if (PlaySoundTemp[i] == "") then
				PlaySound_CharVar.Other[i] = nil
			else
				PlaySound_CharVar.Other[i] = PlaySoundTemp[i]
			end
		end
	end]]
	if (PlaySound_Editor_Mount:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_Mount_EditBox1"):GetText())
		if (PlaySoundTemp[1] == "") then
			PlaySound_CharVar.Other[10] = nil
		else
			PlaySound_CharVar.Other[10] = PlaySoundTemp[1]
		end
	end
	if (PlaySound_Editor_TLowHealth:IsVisible()) then
		local PlaySoundTemp = {}
		table.insert(PlaySoundTemp,getglobal("PlaySound_Editor_TLowHealth_EditBox1"):GetText())
		if (PlaySoundTemp[1] == "") then
			PlaySound_CharVar.Other[11] = nil
		else
			PlaySound_CharVar.Other[11] = PlaySoundTemp[1]
		end
	end
end

function PlaySound_Editor_Toggle_FauxDropDown()
	if (PlaySound_FauxDropDown:IsShown()) then
		PlaySound_FauxDropDown:Hide()
	else
		PlaySound_FauxDropDown:Show()
	end
end

function PlaySound_Editor_FauxDropDownButton_OnClick()
	PlaySound_Editor_Abilities_FauxDropDownText:SetText(this:GetText())
	PlaySound_Editor_Toggle_FauxDropDown()
	for i=1, #PlaySound_CharVar.Abilities do
		if (PlaySound_CharVar.Abilities[i][1] == PlaySound_Editor_Abilities_FauxDropDownText:GetText()) then
			if (PlaySound_CharVar.Abilities[i][2]) then
				getglobal("PlaySound_Editor_Abilities_EditBox1"):SetText(PlaySound_CharVar.Abilities[i][2])
			else
				getglobal("PlaySound_Editor_Abilities_EditBox1"):SetText("")
			end
			if (PlaySound_CharVar.Abilities[i][3]) then
				getglobal("PlaySound_Editor_Abilities_EditBox2"):SetText(PlaySound_CharVar.Abilities[i][3])
			else
				getglobal("PlaySound_Editor_Abilities_EditBox2"):SetText("")
			end
		break
		end
	end
end

function PlaySound_FauxDropDown_ScrollBar_Update()
	local line
	local lineplusoffset
	FauxScrollFrame_Update(PlaySound_FauxDropDown_ScrollBar,#PlaySound_FauxDropDown_Data,10,16)
	for line=1,10 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(PlaySound_FauxDropDown_ScrollBar)
		if (lineplusoffset <= #PlaySound_CharVar.Abilities) then
			getglobal("PlaySound_FauxDropDown_Entry"..line):SetText(PlaySound_FauxDropDown_Data[lineplusoffset])
			getglobal("PlaySound_FauxDropDown_Entry"..line):Show()
		else
			getglobal("PlaySound_FauxDropDown_Entry"..line):Hide()
		end
	end
end

function PlaySound_Editor_EditBox_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT")
	GameTooltip:SetText("Enter sound filename\ni.e. funny.wav")
	GameTooltip:Show()
end

function PlaySound_Editor_EditBox_OnLeave()
	GameTooltip:Hide()
end